#include "elementSoleno.h"
#include "mixedTools.h"


elementSoleno::elementSoleno() :  abstractElement() 
{
    cout << " passage constructeur elementSoleno " << endl;
    setDefaultValues();
    setDefaults();
    elementName_ = nomdElements("soleno");
    nbParam_ = elementName_.getElementNbParameters();
    parametersString_ = new string[nbParam_+1];
    registerAcceptableSoftware(nomDeLogiciel::transport, TBoolOk);
    registerAcceptableSoftware(nomDeLogiciel::parmela, TBoolOk);
}


  void elementSoleno::setDefaultValues()
  {
    defaultLabel_ = "solnd";
    B0Def_ = 0.0;
    varyB0Def_ = false;
  }

  void elementSoleno::setDefaults()
  {
    label_ = defaultLabel_;
    B0_ = B0Def_;
    varyB0_ = varyB0Def_;
  }


 string* elementSoleno::getParametersString() const 
 {
   cout << " passage elementSoleno::getParametersString() B0_= " << B0_ << endl;
   int compteur = -1;
   parametersString_[++compteur] = mixedTools::intToString(nbParam_);
   parametersString_[++compteur] = label_;
   parametersString_[++compteur] = mixedTools::doubleToString(lenghtElem_);
   parametersString_[++compteur] = mixedTools::doubleToString(aperture_);
   parametersString_[++compteur] = mixedTools::doubleToString(B0_);
   parametersString_[++compteur] = mixedTools::intToString(varyB0_);
   if ( compteur != nbParam_ ) {
     cerr << " elementSoleno::getParametersString() : ERROR nr pf parameters dosnt match " << endl;
     return NULL;
   }
   return parametersString_;
 }


 void  elementSoleno::setParametersString(string* param)
 {
  	if ( param == NULL )
	{
	  cerr << "  elementSoleno::setParametersString parameters empty parameter set";
	  return;
	}
   int compteur = -1;
   int nbparam = atoi(param[++compteur].c_str());
    if ( nbparam != nbParam_ ) 
	{
	  cerr << "  elementSoleno::setParametersString parameters do not match for a SOLENOID";
	  return;
	}
  label_ = param[++compteur];
    lenghtElem_ = atof(param[++compteur].c_str());
    aperture_  = atof(param[++compteur].c_str());
    B0_ = atof(param[++compteur].c_str());
    varyB0_ = atoi(param[++compteur].c_str());
 }

string elementSoleno::parmelaOutputFlow() const
  {
    ostringstream sortie;
    // on passe l'induction magnetique en Gauss 
    sortie << "SOLENOID /l=" << lenghtElem_ << "  /aper=" << aperture_ << "  /iout=1 /h=" << 1000.*B0_  << endl;
    return sortie.str();
  }

string elementSoleno::transportOutputFlow() const
  {
    ostringstream sortie;
    // on passe la longueur en metres 
    sortie << label_ << ":" << "  SOLENOID, L=" << 0.01*lenghtElem_ << ", B=" << B0_ << ";" << endl;
    if ( varyB0_ ) {
      sortie <<  "  VARY, " << label_+"[B]"  << ";" << endl;
    }
    return sortie.str();
  }

string elementSoleno::FileOutputFlow() const
  {
    ostringstream sortie;
    //    sortie << elementName_.getElementType() << endl;
    sortie << elementName_.getElementLabel() << endl;
    sortie  << label_ << endl;
    sortie << lenghtElem_ << "  " << aperture_<< " "  << B0_ << " " << varyB0_ << endl;
    return sortie.str();
  }

void elementSoleno::FileInput(ifstream& ifs)
{
  ifs >> label_;
  ifs >> lenghtElem_ >>  aperture_ >> B0_ >> varyB0_ ;
}


string elementSoleno::print() {
    string txt = "";

    txt += label_;
    txt += "\nlength (cm) : ";
    txt += mixedTools::doubleToString(lenghtElem_);
    txt += "\naperture (cm) : ";
    txt += mixedTools::doubleToString(aperture_);
    txt += "\nfield (kG) : ";
    txt += mixedTools::doubleToString(B0_);
    txt += "\n : may vary ? ";
    txt += mixedTools::boolToString(varyB0_);
    
    return txt;
}
