//
//  GWt_softwarePanel.h
//  PSPA
//
//  Created by Garnier Laurent on 30/01/13.
//  Copyright (c) 2013 Garnier Laurent. All rights reserved.
//

#ifndef __PSPA__GWt_softwarePanel__
#define __PSPA__GWt_softwarePanel__

#include <iostream>
#include <Wt/WContainerWidget>
#include <Wt/WPushButton>

#include "dataManager.h"

using namespace Wt;
using namespace std;

class PspaApplication;

class GWt_softwarePanel  : public WContainerWidget
{
    typedef struct {
        WLineEdit* debut;
        WLineEdit*  fin;
        WComboBox* selection;
        WContainerWidget* ligneDeWidget;
    } GWt_sectionToExecute;

    public :
    GWt_softwarePanel(dataManager*, PspaApplication*);
    virtual ~GWt_softwarePanel();

    void addSectionToExecuteW();
    void updateSelections();
    
    private :
    //    void disableSectionExecute();
    //    void checkSectionSelection();
    bool updateSectionSelection();
    void deleteSectionToExecuteW();
    string getSelection();
    void executer();
    bool areDataCoherent();
    
    list<GWt_sectionToExecute*> selectedSections_;
    dataManager* dtmanage_;
    WPushButton *exec_go_;
    WContainerWidget* contenuSections_;
    PspaApplication* pspa_;

};

#endif /* defined(__PSPA__GWt_softwarePanel__) */
