#include "GWt_rfgun.h"
#include "mixedTools.h"

#include <Wt/WText>
#include <Wt/WLineEdit>
#include <Wt/WBreak>
#include <Wt/WDialog>
#include <Wt/WPushButton>

GWt_rfgun::GWt_rfgun(GWt_elementLigneFaisceau* elemLigne)
:GWt_abstractElement(new elementRfgun())
{
  elementLigneFaiseauContainer_ = elemLigne;
  initialize();
}

void GWt_rfgun::initilializeDialog() 
{
  string* param = beginDialog();
    
  new WText("nr of macroparticles : ",dialog_->contents());
  nmacropEdit_ = new WLineEdit(param->c_str(), dialog_->contents());
  new WBreak(dialog_->contents());
    
  new WText("sigma_t (ps) : ",dialog_->contents());
  sigma_tEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
  new WBreak(dialog_->contents());
  
  new WText("sigma_r (cm) : ",dialog_->contents());
  sigma_rEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
  new WBreak(dialog_->contents());
    
  new WText("emittance x (pi.mm.mrad) : ",dialog_->contents());
  emit_xEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
  new WText("emittance y (pi.mm.mrad) : ",dialog_->contents());
  emit_yEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
  new WBreak(dialog_->contents());
  
  new WText("initial kinetic energy (MeV) : ",dialog_->contents());
  E_cinEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
  new WBreak(dialog_->contents());
    
  new WText("sigma_Ecin (MeV) : ",dialog_->contents());
  sigma_EEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
  new WBreak(dialog_->contents());
    
  new WText("total charge in beam (nC) : ",dialog_->contents());
  totalChargeEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
  new WBreak(dialog_->contents());
  
  WPushButton *annule= new WPushButton("cancel",dialog_->contents()); 
  annule->clicked().connect(dialog_, &Wt::WDialog::reject);
  WPushButton *submit= new WPushButton("OK",dialog_->contents());
  submit->clicked().connect(dialog_, &Wt::WDialog::accept);
  dialog_->finished().connect(this, &GWt_rfgun::dialogDone);
}

void GWt_rfgun::dialogDone(WDialog::DialogCode code)
{
  if (code != Wt::WDialog::Accepted) return;

  unsigned nbParam = abstractElement_->getNbParams();
  string* envoi = new string[nbParam+1];
  int compteur = -1;

  envoi[++compteur] = mixedTools::intToString(nbParam);
  envoi[++compteur] = labelEdit_->text().toUTF8();
  envoi[++compteur] = nmacropEdit_->text().toUTF8();
  envoi[++compteur] = sigma_tEdit_->text().toUTF8();
  envoi[++compteur] = sigma_rEdit_->text().toUTF8();
  envoi[++compteur] = emit_xEdit_->text().toUTF8();
  envoi[++compteur] = emit_yEdit_->text().toUTF8();
  envoi[++compteur] = E_cinEdit_->text().toUTF8();
  envoi[++compteur] = sigma_EEdit_->text().toUTF8();
  envoi[++compteur] = totalChargeEdit_->text().toUTF8();
  if ( compteur !=  (int)nbParam ) {
    cerr << " GWt_rfgun::dialogDone() pb nb de parametres, compteur = " << compteur << " nbParam= " << nbParam << endl;
    return;
  }
  abstractElement_->setParametersString(envoi);
  updateLabelAndToolTipWidget();
  delete [] envoi;
}

WImage* GWt_rfgun::getImage() {
  return image_;
}
